////////////////////////////////////////////////////
// Aufgabe 6 Kapitel Prozeduren
//cx und cy sind die interessanten Parameter, die 
//für das Aussehen der Map verantwortlich sind
//Hier werden automatisch für verschiedene cx die
//entsprechenden Bilder gespeichert.
//Nur bei wenigen Punkten werden die Bilder auch 
//angezeigt
////////////////////////////////////////////////////
float cx, cy;
int [] punktKoord = {0,0};
float[] punkt = {0.0,0.0};
float  xalt, yalt;
int w,h,n,i;
color farbe;
PFont font;
PImage screen;
////////////////////////////////////////////////////
void setup() {
  w=900; h=900;
  surface.setSize(w,h);  
  background (255); //weißer Bildhintergrund
  fill(0);//Schriftfarbe schwarz
  farbe = color(0,0,0);
  xalt= 0.04; yalt= 0;//Startwerte
  cx = 1.7; cy = 1; //Wahl der Parameter
  n= 500000;//maximale Anzahl der Iterationschritte
  i =0; 
  stroke(0,0,0);
}
////////////////////////////////////////////////
float[] iteration(float x, float y){
  float xalt = x; float yalt = y;
  punkt[0] = 1-yalt+cx*abs(xalt); 
  punkt[1] = cy*xalt;
  return punkt;
}
///////////////////////////////////////////////////
int[] koordinaten(float x, float y){
  //Bildausschnitt links unten (xu;yu), rechts oben (xo,yo)
  int xu = -100; int xo = 300;
  int yu = -100; int yo = 300;
  float xneu = x; float yneu = y;
   punktKoord[0] = round((xneu-xu)/(xo-xu)*w);
   punktKoord[1] = round((yo-yneu)/(yo-yu)*h);
   return punktKoord; 
}
////////////////////////////////////////////////////////
void textAusgeben(String s){
  String text = s;
  //So wird der aktuelle Wert von cx im Bild mit abgespeichert: 
  text("cx = " + text,60,80); 
}
//////////////////////////////////////////////////////////
void draw () {
    cx = cx + 0.001; println(cx);
     while ((i<n) && (abs(xalt)<100000) &&  (abs(yalt)<100000)) {
        
       //stoppt wenn maximale Induktionstiefe erricht oder  bei Divergenz    
       punkt = iteration(xalt,yalt);
       xalt = punkt[0]; yalt = punkt[1];
       punktKoord = koordinaten(xalt,yalt);  
       point(punktKoord[0],punktKoord[1]);
       i++;
    }
  //Speichern und stoppen, wenn eine der drei Bedingungen erfüllt ist  
   if ((i>=n) || (abs(xalt)>=100000) || (abs(yalt)>=100000) ){
     if(i>=n){
      textAusgeben(str(cx));
      saveFrame("GingerBreadMan-####.png");
      background (255); 
     }    
      i=0;
       xalt= 0.04; yalt= 0;
   } 
    if(cx > 1.9) {noLoop();}
}